.docpub:build-docs:
  id_tokens:
    DOC_JWT:
      aud: doc-publisher
  variables:
    # The directory where your job generates the docs
    DOCS_DIR: docs
    # An identifier for your docs that can be referenced later by a publishing job
    DOCS_ID: DEFAULT
  after_script:
    - TARGET_DIR="$DOCS_ID/$DOCS_DIR"
    - mkdir -p "$TARGET_DIR"
    - cp -pr $DOCS_DIR/* "$TARGET_DIR"
    - echo ${DOCS_ID}_DOC_JWT=$DOC_JWT >> doc-build.env
    - echo ${DOCS_ID}_DOCS_DIR="$TARGET_DIR" >> doc-build.env
  artifacts:
    reports:
      dotenv: doc-build.env
    paths:
      - "$DOCS_ID/$DOCS_DIR"
    expire_in: 1 hour

.docpub:publish-docs:
  image: docker-registry.wikimedia.org/repos/releng/docpub
  variables:
    # The desired publication location. Must be a subpath of the project path. The `repos` portion in the top-level
    # segment of the path will be removed
    #
    # Default is the project path
    PUB_LOCATION: $CI_PROJECT_PATH

    # Whether the docs are a test coverage report. PUB_LOCATION will be pre-appended with `cover`
    #
    # Default is False
    COVERAGE: 'false'

    # Identifier for the docs to be used
    DOCS_ID: DEFAULT

    ## Internal variables. Modification can make the publishing pipeline fail ##

    # Checking out the code of the repository calling docpub is not necessary. We can skip this operation altogether.
    # See: https://docs.gitlab.com/ee/ci/runners/configure_runners.html#git-strategy
    GIT_STRATEGY: none
  script:
    - trigger_docpub.py
